

#property copyright "Modified lukefx"
#property indicator_chart_window

#define NBSL   12       // number of blue shade levels
#define NSVR    29     // number of solid vertical lines


// input params
extern string info_____ = "---- Time Frames (in minutes) ----";
extern int TF1 = 0;




static int prevtime,prev_short_setup,prev_long_setup,toggle_status;
static double prev_win_price_min;
string info____ = "---- Chart Shift, Spacing and Width ----";
extern int Shift = +300;
extern int Spacing = 0;
extern int Width = -3000;


static int started;
// vars
int counted_bars, startBar, bar, i;

int tf, c, offset, xUnit;
int shift, spacing, width;
int tfa[0];
double point;
double fml[1][7];                               // momentum lines
double bsl_up[4][NBSL];                         // blue shades levels to the up side
double bsl_down[4][NBSL];                       // blue shades levels to the down side

int srgap;                                           // blue shades distances
double bsl[NBSL];                               // blue shades distances ('point' adjusted)
double tmpArray[7], lowestMA, highestMA;
                            
double price;
string objName;
datetime curTime;
int ma_period[7];
//color blueShade[NBSL] = {LightBlue, LightSkyBlue, CornflowerBlue, RoyalBlue, Blue};
//color blueShade[NBSL] = {White,WhiteSmoke, C'238,238,238', 
//C'221,221,221', C'212,212,212', C'214,214,214', C'206,206,206', C'191,191,191', C'180,180,180', C'167,167,167', C'160,160,160', C'155,155,155'};
color blueShade[NBSL] = {C'216,239,255', C'167,224,254', 
C'96,215,255', C'1,191,223', C'16,137,218', C'16,137,218', C'16,137,218', C'16,137,218', C'16,137,218', C'16,137,218', C'16,137,218'};


color col;
int ma[10];
int tft[10];
color traffic_light_color[10];

 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

deinit();
if(started!=-999)
{

started=-999;
}
   
    tfa[0] = TF1;
    
   
    

    xUnit = Period() * 1440;
    shift = Shift * xUnit;
    spacing = Spacing * xUnit;
    width = Width * xUnit;
    
  
    
double OneDecimal  [NBSL] = {9, 16, 26, 42, 68, 110, 178, 288,466,754,1220,11974,3194};
// double OneDecimal  [NBSL] = {1, 2, 3, 5, 13, 21, 55, 89,144,233,377,610,987};
    for (i=0; i<NBSL; i++)
        bsl[i] = OneDecimal[i]*point;

  

    // creating the objects for drawing the grid    
    for (tf=0; tf<1; tf++)
    {
        // blue shade rectangles and bars
        for (i=0; i<NBSL; i++)
        {
            objName = "bsl_up_rect_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, blueShade[i]);
            
            objName = "ext_bsl_up_rect_"+tf;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Blue);
            
            objName = "bsl_down_rect_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, blueShade[i]);
            
            objName = "ext_bsl_down_rect_"+tf;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Blue);
            
          
           }
        {
        objName = "MidShade_"+tf;
        ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
        ObjectSet(objName, OBJPROP_COLOR, White);
        
        // S&R boxes
        objName = "Box1_"+tf;
        ObjectCreate(objName, OBJ_ARROW, 0, 0, 0);
        ObjectSet(objName, OBJPROP_ARROWCODE, 1);
        objName = "Box2_"+tf;
        ObjectCreate(objName, OBJ_ARROW, 0, 0, 0);
        ObjectSet(objName, OBJPROP_ARROWCODE, 1);
        }
        
}
        
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   
 
    for (tf=0; tf<1; tf++)
    {
        for (i=0; i<NBSL; i++)
        {
            ObjectDelete("bsl_up_rect_"+tf+"_"+i);
            ObjectDelete("bsl_down_rect_"+tf+"_"+i);
            ObjectDelete("bsl_up_bar_"+tf+"_"+i);
            ObjectDelete("bsl_down_bar_"+tf+"_"+i);

        }
            ObjectDelete("ext_bsl_down_rect_"+tf);
            ObjectDelete("ext_bsl_up_rect_"+tf);
            ObjectDelete("ext_up_svr_"+tf);
            ObjectDelete("ext_down_svr_"+tf);
        ObjectDelete("MidShade_"+tf);
        
        ObjectDelete("Box1_"+tf);
        ObjectDelete("Box2_"+tf);
        
        for (i=0; i<7; i++)
            ObjectDelete("Ma"+tf+"_"+i);
            
        for (i=1; i<=NSVR; i++)
            ObjectDelete("svr_"+tf+"_"+i);
    }

    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
ma_period[0] = 13;
ma_period[1] = 21;
ma_period[2] = 34;
ma_period[3] = 55;
ma_period[4] = 89;
ma_period[5] = 144;
ma_period[6] = 233;
 double average1,average2;
  
   int tfc,mac;
   
  
  
  
   

   for(tfc=0; tfc<1; tfc++)
   {
   for(mac=0; mac<7; mac++)
   {
   average1=iMA(Symbol(),tft[tfc],ma[mac],0,MODE_SMA,PRICE_CLOSE,0);
   average2=iMA(Symbol(),tft[tfc],ma[mac],0,MODE_SMA,PRICE_CLOSE,1);
  
                                                                                          
   
   string obj_name;
   obj_name="Light "+DoubleToStr(tfc,0)+DoubleToStr(mac,0);
  
   
   }
   }
   
   

point=Point;
if(point<0.0001) point=0.0001;

int short_gap_count;
int long_gap_count;
int sr_short_gap_count;
int sr_long_gap_count;

 init();


 
    curTime = Time[0];
//    price = Bid;
    price = Close[0];
    
    for (tf=0; tf<2; tf++)
    {
//        bar = 0;
        bar = iBarShift(NULL, tfa[tf], curTime, false);

        // populating the fml array...
        for (i=0; i<7; i++)
            {
            fml[tf][i] = iMA(NULL, tfa[tf], ma_period[i], 0, MODE_SMA, PRICE_CLOSE, bar/Period());}
         
        // finding the highest and lowest MAs from the 7 fml's
        for (i=0; i<7; i++)
            tmpArray[i] = fml[tf][i];     // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
        ArraySort(tmpArray);
        lowestMA = tmpArray[0];
        highestMA = tmpArray[6];

        // populating the bsl arrays...
        for (i=0; i<NBSL; i++)
        {
            bsl_up[tf][i] = lowestMA + bsl[i];
            bsl_down[tf][i] = highestMA - bsl[i];
        }
    }
    
    // OK... now drawing
    for (tf=0; tf<1; tf++)
    {
        // drawing the blue shades of the grid from top to bottom
        
        // find the number of overlapping shades
        offset = 0;
        for (i=offset; i<NBSL-1; i++)
            if (bsl_up[tf][i] <= bsl_down[tf][i])
                offset++;
//Print(offset);
        // hide the objects of the first level of overlapping so they wont be left as 'ghosts'
        if (offset > 0)
        {
            objName = "bsl_up_rect_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

            objName = "bsl_up_bar_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
        }
        
        double highest=0;
        for (i=NBSL-2; i>=offset; i--)
        {
            objName = "bsl_up_rect_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i+1]);
                
            if (bsl_down[tf][i]>highest) highest=bsl_up[tf][i+1];
            
            objName = "bsl_up_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i]);
        }
          
          
       objName = "ext_bsl_up_rect_"+tf;
       ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
       ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
       ObjectSet(objName, OBJPROP_PRICE1, highest);
       ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());
            
                            objName = "ext_up_svr_"+tf;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+6*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+6*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, highest+2);
                ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());   
                            ObjectSet(objName, OBJPROP_COLOR, Green); 
        objName = "MidShade_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
        ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
        ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][offset]);
        ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][offset]);

        // hide the objects of the first level of overlapping so they wont be left as 'ghosts'
        if (offset > 0)
        {
            objName = "bsl_down_rect_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

            objName = "bsl_down_bar_"+tf+"_"+(NBSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
        }
           
      
        double lowest=9999.9999;
        for (i=0; i<NBSL-1; i++)
        {
            objName = "bsl_down_rect_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i+1]);
         
            if (bsl_down[tf][i]<lowest) lowest=bsl_down[tf][i+1];
            
            objName = "bsl_down_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i]);
        }
        
            objName = "ext_bsl_down_rect_"+tf;
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, lowest);
            ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
        
                        objName = "ext_down_svr_"+tf;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+6*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+6*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, lowest);
                ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
       

        
   }
       
 return(0);
}
       

 


  
  
  
  
  
  

  